class StreamingMultiprocessor:
    def __init__(self, SMID):
        self.__SMID = SMID
        self.__warpToTrace = {}
        self.__condensedTrace = []
    
    def addToCondensedTrace (self, warpID, ipointID, time):
        self.__condensedTrace.append((warpID, ipointID, time))
        
    def getCondensedTrace (self):
        return self.__condensedTrace
    
    def addWarp (self, warpID):
        self.__warpToTrace[warpID] = []
    
    def hasWarp (self, warpID):
        return warpID in self.__warpToTrace
    
    def addToWarpTrace (self, warpID, timingTuple): 
        assert warpID in self.__warpToTrace, "Unable to find warp in SM %d" % self.__SMID
        self.__warpToTrace[warpID].append(timingTuple)
        
    def numberOfWarps (self):
        return len(self.__warpToTrace)
        
    def __iter__ (self):
        return self.__warpToTrace.iteritems()
    
class WarpPool:
    def __init__(self, ID):
        self.ID = ID
        self.warps = set([])
        
    def add (self, warpID):
        self.warps.add(warpID)